Index: trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.inf
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.inf	(revision 32394)
+++ trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.inf	(revision 32408)
@@ -29,5 +29,5 @@
 Class=System
 ClassGuid={ce4a90b5-1d8c-435d-b349-232ce55cb17f}
-Provider=%SUN%
+Provider=%ORACLE%
 ;edit-DriverVer=08/26/2008,2.00.0000
 DriverPackageType=KernelService
@@ -44,6 +44,6 @@
 
 [Manufacturer]
-;x86 %SUN%=SUN
-;amd64 %SUN%=SUN, NTamd64
+;x86 %ORACLE%=ORACLE
+;amd64 %ORACLE%=ORACLE, NTamd64
 
 [SourceDisksFiles]
@@ -65,5 +65,5 @@
 
 [Strings]
-SUN = "Sun Microsystems, Inc."
+ORACLE = "Oracle Corporation"
 VBoxDrv.SVCDESC = "VirtualBox Service"
 VBoxDrv.DRVDESC = "VirtualBox Driver"
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetAdp.inf
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetAdp.inf	(revision 32394)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetAdp.inf	(revision 32408)
@@ -96,5 +96,5 @@
 
 [Strings]
-Provider = "Sun Microsystems, Inc."
+Provider = "Oracle Corporation"
 VBoxNetAdp_Desc = "VirtualBox Host-Only Ethernet Adapter"
 DiskDescription = "VirtualBox Host-Only Ethernet Adapter"
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt.inf
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt.inf	(revision 32394)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt.inf	(revision 32408)
@@ -141,5 +141,5 @@
 ; ----------------------------------------------------------------------
 [Strings]
-Provider = "Sun Microsystems, Inc."
+Provider = "Oracle Corporation"
 DiskDescription = "VirtualBox Bridged Networking Driver"
 
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt_m.inf
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt_m.inf	(revision 32394)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt_m.inf	(revision 32408)
@@ -78,5 +78,5 @@
 
 [Strings]
-Provider = "Sun Microsystems, Inc."
+Provider = "Oracle Corporation"
 VBoxNetFltMP_Desc = "VirtualBox Bridged Networking Driver Miniport"
 
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Device/VBoxUSB.inf
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Device/VBoxUSB.inf	(revision 32394)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Device/VBoxUSB.inf	(revision 32408)
@@ -17,5 +17,5 @@
 Class=USB
 ClassGUID={36FC9E60-C465-11CF-8056-444553540000}
-provider=%sun%
+provider=%ORACLE%
 ;edit-DriverVer=08/26/2008,2.00.0000
 ;cat CatalogFile=VBoxUSB.cat
@@ -28,9 +28,9 @@
 
 [Manufacturer]
-;x86   %MfgName%=sun
-;amd64 %MfgName%=sun, NTamd64
+;x86   %MfgName%=ORACLE
+;amd64 %MfgName%=ORACLE, NTamd64
 
-;x86   [sun]
-;amd64 [sun.NTamd64]
+;x86   [ORACLE]
+;amd64 [ORACLE.NTamd64]
 %USB\VID_80EE&PID_CAFE.DeviceDesc%=VBoxUSB.Dev, USB\VID_80EE&PID_CAFE
 
@@ -63,6 +63,6 @@
 
 [Strings]
-sun="Sun Microsystems, Inc."
-MfgName="Sun Microsystems, Inc."
+ORACLE="Oracle Corporation"
+MfgName="Oracle Corporation"
 Disk_Description="VBoxUSB Installation Disk"
 USB\VID_80EE&PID_CAFE.DeviceDesc="VirtualBox USB"
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Filter/VBoxUSBFlt.inf
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Filter/VBoxUSBFlt.inf	(revision 32394)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Filter/VBoxUSBFlt.inf	(revision 32408)
@@ -17,5 +17,5 @@
 [Version]
 Signature         = "$Windows NT$"
-Provider          = %sun%
+Provider          = %ORACLE%
 ;edit-DriverVer = 08/26/2008,2.00.0000
 DriverPackageType = ClassFilter
@@ -59,5 +59,5 @@
 
 [Strings]
-sun                     = "Sun Microsystems, Inc."
+ORACLE                  = "Oracle Corporation"
 VBoxUSBFlt.SvcDesc	= "VirtualBox USB Filter Driver"
 VBoxUSBFlt.MediaDesc 	= "VirtualBox USB Filter Driver Disc"
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Monitor/VBoxUSBMon.inf
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Monitor/VBoxUSBMon.inf	(revision 32394)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Monitor/VBoxUSBMon.inf	(revision 32408)
@@ -17,5 +17,5 @@
 [Version]
 Signature         = "$Windows NT$"
-Provider          = %SUN%
+Provider          = %ORACLE%
 ;edit-DriverVer = 08/26/2008,2.00.0000
 DriverPackageType = KernelService
@@ -25,6 +25,6 @@
 
 [Manufacturer]
-;x86 %SUN%=SUN
-;amd64 %SUN%=SUN, NTamd64
+;x86 %ORACLE%=ORACLE
+;amd64 %ORACLE%=ORACLE, NTamd64
 
 [DefaultInstall.NT]
@@ -55,7 +55,7 @@
 
 [Strings]
-SUN = "Sun Microsystems, Inc."
-VBoxUSBMon.SvcDesc	= "VirtualBox USB Monitor Driver"
-VBoxUSBMon.MediaDesc 	= "VirtualBox USB Monitor Driver Disc"
+ORACLE               = "Oracle Corporation"
+VBoxUSBMon.SvcDesc   = "VirtualBox USB Monitor Driver"
+VBoxUSBMon.MediaDesc = "VirtualBox USB Monitor Driver Disc"
 
 ; Useful constants