Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 32587)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 32588)
@@ -455,9 +455,9 @@
     if (DeviceIoControl (gVBoxDriver, VBOXGUEST_IOCTL_CTL_FILTER_MASK, &maskInfo, sizeof (maskInfo), NULL, 0, &cbReturned, NULL))
     {
-        Log(("VBoxTray: VBoxDisplayThread : DeviceIOControl(CtlMask - or) succeeded\n"));
+        Log(("VBoxTray: VBoxDisplayThread: DeviceIOControl(CtlMask - or) succeeded\n"));
     }
     else
     {
-        Log(("VBoxTray: VBoxDisplayThread : DeviceIOControl(CtlMask) failed, DisplayChangeThread exited\n"));
+        Log(("VBoxTray: VBoxDisplayThread: DeviceIOControl(CtlMask) failed, DisplayChangeThread exited\n"));
         return -1;
     }
@@ -471,13 +471,13 @@
         if (DeviceIoControl(gVBoxDriver, VBOXGUEST_IOCTL_WAITEVENT, &waitEvent, sizeof(waitEvent), &waitEvent, sizeof(waitEvent), &cbReturned, NULL))
         {
-            /*Log(("VBoxTray: VBoxDisplayThread : DeviceIOControl succeded\n"));*/
+            /*Log(("VBoxTray: VBoxDisplayThread: DeviceIOControl succeded\n"));*/
 
             if (NULL == pCtx) {
-                Log(("VBoxTray: VBoxDisplayThread : Invalid context detected!\n"));
+                Log(("VBoxTray: VBoxDisplayThread: Invalid context detected!\n"));
                 break;
             }
 
             if (NULL == pCtx->pEnv) {
-                Log(("VBoxTray: VBoxDisplayThread : Invalid context environment detected!\n"));
+                Log(("VBoxTray: VBoxDisplayThread: Invalid context environment detected!\n"));
                 break;
             }
@@ -487,10 +487,10 @@
                 break;
 
-            /*Log(("VBoxTray: VBoxDisplayThread : checking event\n"));*/
+            /*Log(("VBoxTray: VBoxDisplayThread: checking event\n"));*/
 
             /* did we get the right event? */
             if (waitEvent.u32EventFlagsOut & VMMDEV_EVENT_DISPLAY_CHANGE_REQUEST)
             {
-                Log(("VBoxTray: VBoxDisplayThread : going to get display change information.\n"));
+                Log(("VBoxTray: VBoxDisplayThread: going to get display change information\n"));
 
                 /* We got at least one event. Read the requested resolution
@@ -522,5 +522,5 @@
                     if (fDisplayChangeQueried)
                     {
-                        Log(("VBoxTray: VBoxDisplayThread : VMMDevReq_GetDisplayChangeRequest2: %dx%dx%d at %d\n", displayChangeRequest.xres, displayChangeRequest.yres, displayChangeRequest.bpp, displayChangeRequest.display));
+                        Log(("VBoxTray: VBoxDisplayThread: VMMDevReq_GetDisplayChangeRequest2: %dx%dx%d at %d\n", displayChangeRequest.xres, displayChangeRequest.yres, displayChangeRequest.bpp, displayChangeRequest.display));
 
                         /* Horizontal resolution must be a multiple of 8, round down. */
@@ -534,5 +534,5 @@
 
                         if (enmDriverType == VBOXDISPLAY_DRIVER_TYPE_WDDM)
-                            Log(("VBoxTray: VBoxDisplayThread : Detected WDDM Driver\n"));
+                            Log(("VBoxTray: VBoxDisplayThread: Detected WDDM Driver\n"));
 
                         if (enmDriverType != VBOXDISPLAY_DRIVER_TYPE_UNKNOWN)
@@ -541,9 +541,9 @@
 #endif
                         {
-                            Log(("VBoxTray: VBoxDisplayThread : Display driver is active!\n"));
+                            Log(("VBoxTray: VBoxDisplayThread: Display driver is active!\n"));
 
                             if (pCtx->pfnChangeDisplaySettingsEx != 0)
                             {
-                                Log(("VBoxTray: VBoxDisplayThread : Detected W2K or later.\n"));
+                                Log(("VBoxTray: VBoxDisplayThread: Detected W2K or later\n"));
 
 #ifdef  VBOXWDDM
@@ -557,8 +557,8 @@
                                     if (err == NO_ERROR)
                                     {
-                                        Log(("VBoxTray: VBoxDisplayThread : VBoxDispIfResize succeeded\n"));
+                                        Log(("VBoxTray: VBoxDisplayThread: VBoxDispIfResize succeeded\n"));
                                         break;
                                     }
-                                    Log(("VBoxTray: VBoxDisplayThread : VBoxDispIfResize failed err(%d)\n", err));
+                                    Log(("VBoxTray: VBoxDisplayThread: VBoxDispIfResize failed err(%d)\n", err));
                                 }
 #endif
@@ -575,5 +575,5 @@
                             else
                             {
-                                Log(("VBoxTray: VBoxDisplayThread : Detected NT.\n"));
+                                Log(("VBoxTray: VBoxDisplayThread: Detected NT\n"));
 
                                 /* Single monitor NT. */
@@ -585,5 +585,6 @@
                                 if (EnumDisplaySettings(NULL, ENUM_REGISTRY_SETTINGS, &devMode))
                                 {
-                                    Log(("VBoxTray: VBoxDisplayThread : Current mode: %dx%dx%d at %d,%d\n", devMode.dmPelsWidth, devMode.dmPelsHeight, devMode.dmBitsPerPel, devMode.dmPosition.x, devMode.dmPosition.y));
+                                    Log(("VBoxTray: VBoxDisplayThread: Current mode: %d x %d x %d at %d,%d\n",
+                                          devMode.dmPelsWidth, devMode.dmPelsHeight, devMode.dmBitsPerPel, devMode.dmPosition.x, devMode.dmPosition.y));
 
                                     /* Check whether a mode reset or a change is requested. */
@@ -603,5 +604,5 @@
                                     {
                                         /* All zero values means a forced mode reset. Do nothing. */
-                                        Log(("VBoxTray: VBoxDisplayThread : Forced mode reset.\n"));
+                                        Log(("VBoxTray: VBoxDisplayThread: Forced mode reset\n"));
                                     }
 
@@ -611,5 +612,5 @@
                                         && devMode.dmBitsPerPel == displayChangeRequest.bpp)
                                     {
-                                        Log(("VBoxTray: VBoxDisplayThread : already at desired resolution.\n"));
+                                        Log(("VBoxTray: VBoxDisplayThread: already at desired resolution\n"));
                                         break;
                                     }
@@ -629,5 +630,6 @@
                                         devMode.dmBitsPerPel = displayChangeRequest.bpp;
 
-                                    Log(("VBoxTray: VBoxDisplayThread : setting the new mode %dx%dx%d\n", devMode.dmPelsWidth, devMode.dmPelsHeight, devMode.dmBitsPerPel));
+                                    Log(("VBoxTray: VBoxDisplayThread: setting new mode %d x %d, %d BPP\n",
+                                         devMode.dmPelsWidth, devMode.dmPelsHeight, devMode.dmBitsPerPel));
 
                                     /* set the new mode */
@@ -635,5 +637,5 @@
                                     if (status != DISP_CHANGE_SUCCESSFUL)
                                     {
-                                        Log(("VBoxTray: VBoxDisplayThread : error from ChangeDisplaySettings: %d\n", status));
+                                        Log(("VBoxTray: VBoxDisplayThread: error from ChangeDisplaySettings: %d\n", status));
 
                                         if (status == DISP_CHANGE_BADMODE)
@@ -651,5 +653,5 @@
                                 else
                                 {
-                                    Log(("VBoxTray: VBoxDisplayThread : error from EnumDisplaySettings: %d\n", GetLastError ()));
+                                    Log(("VBoxTray: VBoxDisplayThread: error from EnumDisplaySettings: %d\n", GetLastError ()));
                                     break;
                                 }
@@ -658,5 +660,5 @@
                         else
                         {
-                            Log(("VBoxTray: VBoxDisplayThread : vboxDisplayDriver is not active.\n"));
+                            Log(("VBoxTray: VBoxDisplayThread: vboxDisplayDriver is not active\n"));
                         }
 
@@ -671,5 +673,5 @@
                     else
                     {
-                        Log(("VBoxTray: VBoxDisplayThread : error from DeviceIoControl VBOXGUEST_IOCTL_VMMREQUEST\n"));
+                        Log(("VBoxTray: VBoxDisplayThread: error from DeviceIoControl VBOXGUEST_IOCTL_VMMREQUEST\n"));
                         /* sleep a bit to not eat too much CPU while retrying */
                         /* are we supposed to stop? */
@@ -686,5 +688,5 @@
         } else
         {
-            Log(("VBoxTray: VBoxDisplayThread : error 0 from DeviceIoControl VBOXGUEST_IOCTL_WAITEVENT\n"));
+            Log(("VBoxTray: VBoxDisplayThread: error 0 from DeviceIoControl VBOXGUEST_IOCTL_WAITEVENT\n"));
             /* sleep a bit to not eat too much CPU in case the above call always fails */
             if (WaitForSingleObject(pCtx->pEnv->hStopEvent, 10) == WAIT_OBJECT_0)
@@ -700,12 +702,12 @@
     if (DeviceIoControl (gVBoxDriver, VBOXGUEST_IOCTL_CTL_FILTER_MASK, &maskInfo, sizeof (maskInfo), NULL, 0, &cbReturned, NULL))
     {
-        Log(("VBoxTray: VBoxDisplayThread : DeviceIOControl(CtlMask - not) succeeded\n"));
+        Log(("VBoxTray: VBoxDisplayThread: DeviceIOControl(CtlMask - not) succeeded\n"));
     }
     else
     {
-        Log(("VBoxTray: VBoxDisplayThread : DeviceIOControl(CtlMask) failed\n"));
-    }
-
-    Log(("VBoxTray: VBoxDisplayThread : finished display change request thread\n"));
+        Log(("VBoxTray: VBoxDisplayThread: DeviceIOControl(CtlMask) failed\n"));
+    }
+
+    Log(("VBoxTray: VBoxDisplayThread: finished display change request thread\n"));
     return 0;
 }
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTray.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTray.cpp	(revision 32587)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTray.cpp	(revision 32588)
@@ -283,5 +283,5 @@
 void WINAPI VBoxServiceStart(void)
 {
-    Log(("VBoxTray: Leaving service main function"));
+    Log(("VBoxTray: Entering service main function\n"));
 
     VBOXSERVICEENV svcEnv;